]> git.ipfire.org Git - thirdparty/git.git/blame - git-sh-setup.sh
t/README: A new section about test coverage
[thirdparty/git.git] / git-sh-setup.sh
CommitLineData
b33e9666
LT
1#!/bin/sh
2#
ae2b0f15
JH
3# This is included in commands that either have to be run from the toplevel
4# of the repository, or with GIT_DIR environment variable properly.
5# If the GIT_DIR does not look like the right correct git-repository,
6# it dies.
b33e9666 7
365527ad 8# Having this variable in your environment would break scripts because
e598c517 9# you would cause "cd" to be taken to unexpected places. If you
365527ad
JH
10# like CDPATH, define it for your interactive shell sessions without
11# exporting it.
12unset CDPATH
13
61dbb3c4
JH
14git_broken_path_fix () {
15 case ":$PATH:" in
16 *:$1:*) : ok ;;
17 *)
18 PATH=$(
19 SANE_TOOL_PATH="$1"
20 IFS=: path= sep=
21 set x $PATH
22 shift
23 for elem
24 do
25 case "$SANE_TOOL_PATH:$elem" in
26 (?*:/bin | ?*:/usr/bin)
27 path="$path$sep$SANE_TOOL_PATH"
28 sep=:
29 SANE_TOOL_PATH=
30 esac
31 path="$path$sep$elem"
32 sep=:
33 done
34 echo "$path"
35 )
36 ;;
37 esac
38}
39
40# @@BROKEN_PATH_FIX@@
0e0aea5a 41
b33e9666 42die() {
8098a178 43 echo >&2 "$@"
b33e9666
LT
44 exit 1
45}
46
e064c170
SB
47GIT_QUIET=
48
49say () {
50 if test -z "$GIT_QUIET"
51 then
52 printf '%s\n' "$*"
53 fi
54}
55
bac199b7
PH
56if test -n "$OPTIONS_SPEC"; then
57 usage() {
5d292756
JH
58 "$0" -h
59 exit 1
bac199b7
PH
60 }
61
e817e3e8
PH
62 parseopt_extra=
63 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
64 parseopt_extra="--keep-dashdash"
65
66 eval "$(
cbea86fd 67 echo "$OPTIONS_SPEC" |
e817e3e8
PH
68 git rev-parse --parseopt $parseopt_extra -- "$@" ||
69 echo exit $?
70 )"
bac199b7 71else
1b1dd23f 72 dashless=$(basename "$0" | sed -e 's/-/ /')
bac199b7 73 usage() {
1b1dd23f 74 die "Usage: $dashless $USAGE"
bac199b7
PH
75 }
76
77 if [ -z "$LONG_USAGE" ]
78 then
1b1dd23f 79 LONG_USAGE="Usage: $dashless $USAGE"
bac199b7 80 else
1b1dd23f 81 LONG_USAGE="Usage: $dashless $USAGE
bac199b7
PH
82
83$LONG_USAGE"
84 fi
85
86 case "$1" in
87 -h|--h|--he|--hel|--help)
88 echo "$LONG_USAGE"
89 exit
90 esac
91fi
d025524d 92
f9474132
SP
93set_reflog_action() {
94 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
95 then
96 GIT_REFLOG_ACTION="$*"
97 export GIT_REFLOG_ACTION
98 fi
99}
100
ef0c2abf 101git_editor() {
b4479f07
JN
102 if test -z "${GIT_EDITOR:+set}"
103 then
104 GIT_EDITOR="$(git var GIT_EDITOR)" || return $?
105 fi
106
107 eval "$GIT_EDITOR" '"$@"'
ef0c2abf
AR
108}
109
f6dff119
JN
110git_pager() {
111 if test -t 1
112 then
113 GIT_PAGER=$(git var GIT_PAGER)
114 else
115 GIT_PAGER=cat
116 fi
117 : ${LESS=-FRSX}
118 export LESS
119
120 eval "$GIT_PAGER" '"$@"'
121}
122
e1622bfc
JH
123sane_grep () {
124 GREP_OPTIONS= LC_ALL=C grep "$@"
125}
126
127sane_egrep () {
128 GREP_OPTIONS= LC_ALL=C egrep "$@"
129}
130
4b441f47 131is_bare_repository () {
5be60078 132 git rev-parse --is-bare-repository
4b441f47
JH
133}
134
9fde9401 135cd_to_toplevel () {
91dc602d
SD
136 cdup=$(git rev-parse --show-toplevel) &&
137 cd "$cdup" || {
138 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
139 exit 1
140 }
9fde9401
JH
141}
142
7eff28a9 143require_work_tree () {
ab62677b 144 test "$(git rev-parse --is-inside-work-tree 2>/dev/null)" = true ||
7eff28a9
SP
145 die "fatal: $0 cannot be used without a working tree."
146}
147
0cae2346
JS
148get_author_ident_from_commit () {
149 pick_author_script='
150 /^author /{
151 s/'\''/'\''\\'\'\''/g
152 h
153 s/^author \([^<]*\) <[^>]*> .*$/\1/
154 s/'\''/'\''\'\'\''/g
155 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
156
157 g
158 s/^author [^<]* <\([^>]*\)> .*$/\1/
159 s/'\''/'\''\'\'\''/g
160 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
161
162 g
163 s/^author [^<]* <[^>]*> \(.*\)$/\1/
164 s/'\''/'\''\'\'\''/g
165 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
166
167 q
168 }
169 '
170 encoding=$(git config i18n.commitencoding || echo UTF-8)
077b725f 171 git show -s --pretty=raw --encoding="$encoding" "$1" -- |
0cae2346
JS
172 LANG=C LC_ALL=C sed -ne "$pick_author_script"
173}
174
7d750f0e
GB
175# Clear repo-local GIT_* environment variables. Useful when switching to
176# another repository (e.g. when entering a submodule). See also the env
177# list in git_connect()
178clear_local_git_env() {
179 unset $(git rev-parse --local-env-vars)
180}
181
22c90717
JH
182# Make sure we are in a valid repository of a vintage we understand,
183# if we require to be in a git repository.
70087cdb 184if test -z "$NONGIT_OK"
d025524d 185then
4d6d6d2d 186 GIT_DIR=$(git rev-parse --git-dir) || exit
22c90717
JH
187 if [ -z "$SUBDIRECTORY_OK" ]
188 then
22c90717
JH
189 test -z "$(git rev-parse --show-cdup)" || {
190 exit=$?
191 echo >&2 "You need to run this command from the toplevel of the working tree."
192 exit $exit
193 }
22c90717
JH
194 fi
195 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
196 echo >&2 "Unable to determine absolute path of git directory"
197 exit 1
b2bc9a30 198 }
22c90717 199 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
d025524d 200fi
87bddba9
JS
201
202# Fix some commands on Windows
203case $(uname -s) in
204*MINGW*)
205 # Windows has its own (incompatible) sort and find
206 sort () {
207 /usr/bin/sort "$@"
208 }
209 find () {
210 /usr/bin/find "$@"
211 }
212 ;;
213esac